var app;

(function () {
    'use strict';

    app = {
        environnement: "PROD",
        environnements: {
            DEV: 'DEV',
            PROD: 'PRODUCTION'
        },
        collections: {},
        models: {},
        views: {},
        routers: {},
        init: function () {

            navigator.splashscreen.hide();

            app.routers.app = new app.routers.App();
            Backbone.history.start();

            app.helpers.addAds();

        }
    };

    // DEVICE is READY
    document.addEventListener('deviceready', function () {

        document.addEventListener("backbutton", function (e) {
            e.preventDefault();
        }, false);

        // DOM is READY
        $(document).ready(function () {
            // On lance l'application une fois que notre HTML est chargé
            if (app.environnement === app.environnements.DEV) {
                var scriptsLength = $('.tpl').size();
                var nbScriptsLoaded = 0;
                $('.tpl').each(function (tpl) {
                    var $elm = $(this);
                    $.get($elm.attr('src'), function (html) {

                        var text = $(html.childNodes).outerHTML() || html;
                        $elm.html(text);
                        nbScriptsLoaded++;
                        if (nbScriptsLoaded === scriptsLength) {
                            app.init();
                        }
                    });
                });
            } else {
                app.init();
            }
        });

        navigator.splashscreen.show();

    }, false);


})();


/* extending jquery */
jQuery.fn.outerHTML = function (s) {
    'use strict';
    return s ? this.before(s).remove() : jQuery("<p>").append(this.eq(0).clone()).html();
};


/* extending backbone */
Backbone.View.prototype.close = function () {
    'use strict';
    this.remove();
    this.unbind();
    if (this.onClose) {
        this.onClose();
    }
};

var rp = Backbone.Router.prototype;
rp.routeWithoutEvents = rp.route;
rp.route = function (route, name, callback) {
    'use strict';
    if (!callback) callback = this[name];
    this.routeWithoutEvents(route, name, function () {
        this.before.apply(this);
        callback.apply(this, arguments);
        this.after.apply(this);
    });
};